
// viewtest.l
// by Mark Duchaineau (free but copyrighted, see LibGen/COPYING)
//
// 06-07-93: wrote
// 06-07-99: updated to test multiple spin modes with keypress, esc to quit
// 02-22-00: minor cleanup of function declarations


lib_include "../../geowin.l";

int done,mode;
win w;
view v;

void wevent(win w,int e);
void vevent(view v);
int dtoi(double d);
void do_draw();

lib_main {
    int x,y,size;

    size=512; mode=0;
    win_screensize(&x,&y);
    win_doublebuffer();
    w=win_create("viewtest",x/2-size/2,y/2-size/2,size,size,wevent);
    v=view_create((double)w->xsize/2.0,(double)w->ysize/2.0,(double)size/2.0,
        vevent);
    for (done=0;!done;) sel_wait(300000);
};

void wevent(win w,int e)
{
    int x,y;

    win_mouse(&x,&y);
    switch (e) {
    case WIN_KEY:
        switch (w->key) {
        case '0': mode=0; break;
        case '1': mode=1; break;
        case '2': mode=2; break;
        case 0x1b: done=1; break;
        default:
            break;
        }
        break;
    case WIN_DRAW:
        x=(w->xsize+w->ysize)/2;
        view_resize((double)w->xsize/2.0,(double)w->ysize/2.0,(double)x/2.0);
        do_draw();
        break;
    case WIN_LEFTDOWN:
        win_repeat();
        view_startdragrot((double)x,(double)y);
        break;
    case WIN_LEFTUP:
        win_norepeat();
        break;
    case WIN_REPEAT:
        switch (mode) {
        case 2:
            view_dragrot2((double)x,(double)y);
            break;
        case 1:
            view_dragrot1((double)x,(double)y);
            break;
        case 0:
        default:
            view_dragrot((double)x,(double)y);
            break;
        }
        break;
    case WIN_QUIT:
        done=1;
        break;
    default:
        break;
    }
}

void vevent(view v)
{
    do_draw();
}

int dtoi(double d)
{
    return (int)floor(d+0.5);
}

void do_draw()
{
    int i,k;
    double t0,t1;
    double x0,y0,z0,sx0,sy0,sz0;
    double x1,y1,z1,sx1,sy1,sz1;

    win_color(0,0,0); win_clear();
    for (i= -16;i<16;i++) {
        t0=(double)i/16.0;
        t1=(double)(i+1)/16.0;
        x0=t0; y0=0.0; z0=0.0; view_wtos(x0,y0,z0,&sx0,&sy0,&sz0);
        x1=t1; y1=0.0; z1=0.0; view_wtos(x1,y1,z1,&sx1,&sy1,&sz1);
        view_depthcolor(255,0,0,(sz0+sz1)/2.0);
        win_line(dtoi(sx0),dtoi(sy0),dtoi(sx1),dtoi(sy1));
        x0=0.0; y0=t0; z0=0.0; view_wtos(x0,y0,z0,&sx0,&sy0,&sz0);
        x1=0.0; y1=t1; z1=0.0; view_wtos(x1,y1,z1,&sx1,&sy1,&sz1);
        view_depthcolor(0,255,0,(sz0+sz1)/2.0);
        win_line(dtoi(sx0),dtoi(sy0),dtoi(sx1),dtoi(sy1));
        x0=0.0; y0=0.0; z0=t0; view_wtos(x0,y0,z0,&sx0,&sy0,&sz0);
        x1=0.0; y1=0.0; z1=t1; view_wtos(x1,y1,z1,&sx1,&sy1,&sz1);
        view_depthcolor(0,0,255,(sz0+sz1)/2.0);
        win_line(dtoi(sx0),dtoi(sy0),dtoi(sx1),dtoi(sy1));
    }
    view_drawsphere();
    win_swapbuffers();
}


